
#include 'CDO.ch'
#pragma library( "ascom10.lib" )

//     CDO.Configuration                  http://msdn.microsoft.com/en-us/library/ms526318(v=exchg.10).aspx
//                                        http://msdn.microsoft.com/en-us/library/ms526953(v=exchg.10).aspx
//         NameSpaces                     http://msdn.microsoft.com/en-us/library/exchange/aa486269(v=exchg.65).aspx
//     Individual properties description: http://msdn.microsoft.com/en-us/library/ms526600(v=exchg.10).aspx
//     CDO.Message fields                 http://msdn.microsoft.com/en-us/library/ms526453(v=exchg.10).aspx
//     CDO error codes                    http://msdn.microsoft.com/en-us/library/ms526287(v=exchg.10).aspx
//                                        http://www.cdolive.com/cdo11.htm with decimal value

#define CR                       Chr(13)

 ////////////
 //
FUNCTION SendAnonimousEMail_(cSmtpServer, nSendingMethod,   nSmtpServerPort,    lSmtpUseSsl,;
                                          nAuthenticate,    nConnectionTimeOut, cSenderName,;
                                          cSenderPassword,  cSenderEmail,       cSenderReplyEmail,;
                                          cSubject,         cFrom,              cTo,;
                                          cCc,              cBcc,               cReplyTo,;
                                          cHTMLBody,        cTextBody,          cKeyWords,;
                                          aAttachment,      nDSNOptions,        cError)
 //
 //      Atravs de uma thread executa a funo ApiSendMail_() porque quando ocorre algum erro
 //              em CDO.Message e existem anexos eles tm o acesso impedido pelo Sistema Operacional
 //      at o encerramento da thread onde foi executado.
 //
 //      Veja a descrio dos parmetros em ApiSendMail_()
 //
 //      Retorna .t. se a mensagem foi enviada com sucesso.
 /////
LOCAL  oThread, cId, lOk, nCount, nInd, nLen, hFree, cLocked

if     !Empty(cTo)
       cId := cTo
elseif !Empty(cCc)
       cId := cCc
elseif !Empty(cBcc)
       cId := cBcc
endif
if cId  <> NIL
   nInd := At(',', cId)
   if nInd  > 0
      cId  := (Left(cId, (nInd - 1))  + ',...')
   else
      nInd    := At(';', cId)
      if nInd  > 0
         cId  := Left(cId, (nInd - 1) + ',...')
      endif
   endif
   cId := ('E-mail to ' + cId)
endif

oThread := Thread():new(NIL, cId)
lOk     := oThread:start({|| ApiSendMail_(cSmtpServer,     nSendingMethod,     nSmtpServerPort,    lSmtpUseSsl,;
                                          nAuthenticate,   nConnectionTimeOut, cSenderName,;
                                          cSenderPassword, cSenderEmail,       cSenderReplyEmail,;
                                          cSubject,        cFrom,              cTo,;
                                          cCc,             cBcc,               cReplyTo,;
                                          cHTMLBody,       cTextBody,          cKeyWords,;
                                          aAttachment,     nDSNOptions,        @cError)})
if lOk
   oThread:synchronize(0)
   do While oThread:active
      Sleep(10)
   enddo
                  //
                  //    Tendo em vista que CDO.Message pode reter os anexos como reservados at
                  //          a finalizao do processo que enviou a mensagem, foraremos a
                  //    execuo do "Garbage Collector" do Xbase++ a fim de liberar todos os
                  //    recursos usados por Thread(), encerrando-a imediatamente
   oThread := NIL                // Para forar a liberao da Thread e recursos envolvidos
                  //
                  //    Esperaremos at 15 segundos para ver se cada anexo j pode ser usado.
                  //    Caso este tempo seja insuficiente,  acrescentada uma mensagem com o
                  //    motivo no parmetro <cError>.
   nCount := 0
   if !Empty(aAttachment)
      nLen   := Len(aAttachment)
      for nInd  := 1 to nLen
          hFree := FOpen(aAttachment[nInd])
          if hFree > 0
             FClose(hFree)
             nCount := 0
          else
             Sleep(50)
             if ++nCount == 30
                exit
             endif
             nInd -= 1
          endif
      next
   endif
   if nCount  == 30
      cLocked := ('Anexo  mensagem: ' + aAttachment[nInd] + CR +;
                  'no foi liberado pelo Sistema Operacional')
      if Empty(cError)
         cError := cLocked
      else
         cError += (cError + CR + cLocked)
      endif
   endif
   lOk := !Empty(cError)
endif
RETURN lOk

 ////////////
 //
 //   ApiSendMail_()
 //     D O C U M E N T A   O   G E R A L
 //
 // iVars:     CDO.ch
 //
 // CDO.Configuration
 //     CDO.Configuration                  http://msdn.microsoft.com/en-us/library/ms526318(v=exchg.10).aspx
 //                                        http://msdn.microsoft.com/en-us/library/ms526953(v=exchg.10).aspx
 //     Individual properties description: http://msdn.microsoft.com/en-us/library/ms526600(v=exchg.10).aspx
 //     CDO.Message                        http://msdn.microsoft.com/en-us/library/ms526453(v=exchg.10).aspx
 //     CDO error codes                    http://msdn.microsoft.com/en-us/library/ms526287(v=exchg.10).aspx
 //                                        http://www.cdolive.com/cdo11.htm with decimal values
 //     Examples                           http://www.paulsadowski.com/wsh/cdo.htm
 //
 //     Xbase++ field initialization:
 //     The synthaxy to be used may be one or another:
 //                  As write in MSN documentation:
 //       objMessage.Configuration.Fields.Item _("http://schemas.microsoft.com/cdo/configuration/smtpserver") = "mail.myserver.com"
 //                  In Xbase++:
 //       1) oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/smtperver", "mail.server.com")
 //       2) oFields:setProperty("Item", "cdosmtpserver", 'mail.example.com')
 //
 //   FOR CONFIGURATINg NEWS GROUPS
 //             FieldName in :setProperty()
 //       "nntpauthenticate"          - constante http://schemas.microsoft.com/cdo/configuration/nntpauthenticate
 //                                     See "smtpauthenticate"
 //       "postemailaddress"          - constant http://schemas.microsoft.com/cdo/configuration/postemailaddress
 //                                              // The user's return email address for posted messages
 //       "postpassword"              - constant http://schemas.microsoft.com/cdo/configuration/postpassword
 //                                              //The password used with postusername when authenticating
 //                                                // with an NNTP service if the "nntpauthenticate" field
 //                                                // is set to cdoBasic (1)
 //       "postusername"              - constant http://schemas.microsoft.com/cdo/configuration/postusername
 //                                              //The username used with postpassword when authenticating to an NNTP
 //                                                // service if the nntpauthenticate field is set to cdoBasic (1).
 //                                                // The name must be the fully qualified domain account name, such
 //                                                // as (domain)\(username) when authenticating with a service participating
 //                                                // in an Windows NT domain system.
 //       "postuserreplyemailaddress" - constant http://schemas.microsoft.com/cdo/configuration/postuserreplyemailaddress
 //                                                   // The reply email address. This value is used when
 //                                                     // constructing the headers for posted messages
 //       "postusing"                 - constant http://schemas.microsoft.com/cdo/configuration/postusing
 //                                              // Specifies the method used when posting NNTP messages.
 //                                                 //     Values (defined in CDO.ch)
 //                                                 //     cdoPostUsingPickup  := 1  -> Post the message using the local NNTP service pickup directory.
 //                                                 //     cdoPostUsingPort    := 2  -> Post the message using NNTP over the network.
 //
 //   FOR CONFIGURATION SMTP
 //             FieldName in :setProperty
 //       "cdosendemailaddress"       - constant http://schemas.microsoft.com/cdo/configuration/sendemailaddress
 //                                              // The user's email address used when connecting to the SMTP service.
 //       "cdosendpassword"           - constant http://schemas.microsoft.com/cdo/configuration/sendpassword
 //                                              // The password used to authenticate to an SMTP server using basic
 //                                                 //      Values (defined in CDO.ch)
 //                                                 // cdoBasic     := 1 Usar autenticao bsica Clear-Text . Ao usar essa opo
 //                                                 //                   voc precisar fornecer o nome usurio e senha atravs
 //                                                 //                   dos campos sendusername e sendpassword
 //                                                 // cdoAnonymous := 0 No autenticam.
 //                                                 // cdoNTLM      := 2 O atual contexto de segurana processo  usado para autenticar
 //                                                 //                   com o servio.
 //       "cdosendusername"           - constant http://schemas.microsoft.com/cdo/configuration/sendusername
 //                                              //The username for authenticating to an SMTP server using basic
 //       "cdosenduserreplyemailaddress" - constant http://schemas.microsoft.com/cdo/configuration/senduserreplyemailaddress
 //                                                // This value is normally set if the From address is not where email
 //                                                   // replies should be sent.
 //       "cdosendusingmethod"         - constante http://schemas.microsoft.com/cdo/configuration/sendusing
 //                                               // Specifies the method used to send messages.
 //                                                  // If a local SMTP service is available, this field defaults to
 //                                                  //     Values (defined in CDO.ch)
 //                                                  //     cdoSendUsingPickup   := 1 Send message using the local SMTP service pickup directory.
 //                                                  //     cdoSendUsingPort     := 2 Send the message using the network (SMTP over the network).
 //       "cdosmtpauthenticate"       - constante http://schemas.microsoft.com/cdo/configuration/smtpauthenticate
 //                                              // Specifies the authentication mechanism to use when authentication is required to send
 //                                                 // messages to an SMTP service using a TCP/IP network socket.
 //                                                 // If no value is set for this field, anonymous (no authentication) is assumed.
 //                                                 // This field is used only if the field "cdoSendUsing"
 //                                                 // is set to "cdoSendUsingPort".
 //                                                 // These settings mean that messages are to be sent or posted over the network.
 //                                                 //      Values (defined in CDO.ch)
 //                                                 // cdoBasic     := 1 Usar autenticao bsica Clear-Text . Ao usar essa opo
 //                                                 //                   voc precisar fornecer o nome usurio e senha atravs
 //                                                 //                   dos campos sendusername e sendpassword
 //                                                 // cdoAnonymous := 0 No autenticam.
 //                                                 // cdoNTLM      := 2 O atual contexto de segurana processo  usado para autenticar
 //                                                 //                   com o servio.
 //       "cdosmtpconnectiontimeout"  - constante Long http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout
 //                                                // Indicates the number of seconds to wait for a valid socket to be established
 //                                                   // with the SMTP service before timing out.
 //                                                   // The default is 30 seconds.
 //                                                   // This field is ignored unless the field CdoConfiguration.cdoSendUsingMethod
 //                                                   // is set to cdoSendUsingPort (2).
 //       "cdosmtpserver"             - constante http://schemas.microsoft.com/cdo/configuration/smtpserver
 //                                              // This field is used when the field "cdoSendUsing"
 //                                              // is set to cdoSendUsingPort.
 //       "cdosmtpserverport"         - constante http://schemas.microsoft.com/cdo/configuration/smtpserverport
 //                                              // The port on which the SMTP service specified by the smtpserver field is
 //                                                 // listening for connections.
 //                                                 // The default and well-known port for an SMTP service is 25.
 //       "cdosmtpusessl"             - constante http://schemas.microsoft.com/cdo/configuration/smtpusessl
 //                                             // Indicates that Secure Sockets Layer (SSL) should be used when sending messages
 //                                                // using the SMTP protocol over the network.
 //                                                // This field is only meaningful when the field CdoConfiguration.cdoSendUsingMethod
 //                                                // is set to CdoSendUsingPort. The default is False
 //
 //
 //  CDO.Message
 //        http://msdn.microsoft.com/en-us/library/ms526559(v=exchg.10).aspx
 //      :subject                               Objeto da mensagem
 //      :From  (reserved in XBase++)           The string in the From property represents the full messaging addresses of the
 //                                             message author or authors, as shown in the following example:
 //                                             "Jane Doe" <example@example.com>, <example@example.com>, example2@example.com
 //                                             Commas serve as address separators; however, commas are not parsed as separators when
 //                                             they appear in an address that is enclosed in double quotes, such as the following:
 //                                             "John Jones, Jr." <example@example.com>, "Jane Doe" <example@example.com>
 //      :To, :Cc, :Bcc                         Commas serve as address separators; however, commas are not parsed as separators when
 //                                             they appear in an address that is enclosed in double quotes, such as the following:
 //                                             'example@example.com'
 //                                             ""John Jones, Jr." <example@example.com>"
 //                                             "example@example.com, "John Jones, Jr." <example@example.com>, "Jane Doe" <example@example.com>"
 //      :ReplyTo                               destinatrio da resposta da mensagem.
 //                                             Assume: e-mail constante em :From
 //      :DSNOptions                            cdoDSNDefault             0  No delivery status notifications are issued.
 //                                             cdoDSNNever               1  No delivery status notifications are issued.
 //                                             cdoDSNFailure             2  Returns a delivery status notification if delivery fails.
 //                                             cdoDSNSuccess             4  Returns a delivery status notification if delivery succeeds.
 //                                             cdoDSNDelay               8  Returns a delivery status notification if delivery is delayed.
 //                                             cdoDSNSuccessFailOrDelay 14  Returns a delivery status notification if delivery succeeds,
 //                                                                          fails, or is delayed.
 //                                             Vide em CabDefs.ch cabMAIL_NOTIFY ...
 //      :KeyWords                              The keywords of a message can be useful for determining if the message is of
 //                                             interest to the reader, or for searching for relevant messages in a collection.
 //                                             The string in the Keywords property can represent a single keyword or multiple keywords.
 //                                             A keyword string can optionally contain spaces, such as the following:
 //                                                       "1997 payroll"
 //                                                       Multiple keywords in the list are separated by commas, as in the following example:
 //                                                       "operating systems,Windows NT,functions"
 //
 //      AddAttachment(<cFullPathName>) pode-se ter vrios mtodos
 //      Other many properties, also to send HTML, see the URL above
 //
 //      'The line below shows how to send using HTML included directly in your script
 //      objMessage.HTMLBody = "<h1>This is some sample message html.</h1>"
 //
 //      'The line below shows how to send a webpage from a remote site
 //      'objMessage.CreateMHTMLBody "http://www.paulsadowski.com/wsh/"
 //
 //      'The line below shows how to send a webpage from a file on your machine
 //      'objMessage.CreateMHTMLBody "file://c|/temp/test.htm"
 //
FUNCTION ApiSendMail_(cSmtpServer, nSendingMethod,   nSmtpServerPort,    lSmtpUseSsl,;
                                   nAuthenticate,    nConnectionTimeOut, cSenderName,;
                                   cSenderPassword,  cSenderEmail,       cSenderReplyEmail,;
                                   cSubject,         cFrom,              cTo,;
                                   cCc,              cBcc,               cReplyTo,;
                                   cHTMLBody,        cTextBody,          cKeyWords,;
                                   aAttachment,      nDSNOptions,        cError)
 //      Envia e-mails annimos usando os objetos CDO usando um SMTP remoto, ou seja independe do
 //            padro instalado no computador onde esta funo  executada.
 //      Vide documentao mais completa acima.
 //
 //      PARMETROS:
 //         <cSmtpServer>         -> servidor para o envio de mensagens.
 //                                  Exemplos: 'smtp.bipbip.com.br'
 //        [<nSendingMethod>]     -> mtodo do envio de mensagem.
 //                                  Assume: cdoSendUsingPort
 //         <nSmtpServerPort>     -> porta a ser usada pelo servidor para o envio de mensagem.
 //                                  Obtida na configurao do servidor SMTP no OutLook ou no ThunderBird
 //                                  Assume: cdoServerPort
 //        [<lSmtpUseSsl>]        -> usar o Secure Sockets Layer (SSL) para enviar a mensagem?
 //                                  Depende da configurao do servidor.
 //                                  Assume: .f.
 //        [<nAuthenticate>]      -> forma de autenticao a ser usada no envio da mensagem.
 //                                  Depende da configurao do servidor.
 //                                  cdoAnonymous  := 0 -> Do not authenticate.
 //                                  cdoBasic      := 1 -> Use basic (clear-text) authentication.
 //                                                        The configuration sendusername/sendpassword
 //                                                        or postusername/postpassword fields are
 //                                                        used to specify credentials.
 //                                   cdoNTLM      := 2 -> Use NTLM authentication (Secure Password
 //                                                        Authentication in Microsoft Outlook Express).
 //                                                        The current process security context is
 //                                                        used to authenticate with the service.
 //                                  Assume: cdoBasic
 //        [<nConnectionTimeOut>] -> quanto tempo, em segundos, deve-se esperar para se estabelecer a
 //                                  conexo.
 //                                  S  utilizado quando quando <nSendingMethod> == cdoSendUsingPort.
 //                                  Assume: 60
 //         <cSenderName>         -> e-mail ou nome do usurio definido para o servidor de SMTP
 //                                  Exemplo:
 //                                          Servidor: mail.dominio.com.br
 //                                          Usurio: dominio ou
 //                                                   email@dominio.com.br
 //         <cSenderPassword>     -> senha (password) usada para acessar o servidor.
 //                                  Exemplo: 'MyPassWord'
 //        [<cSenderEmail>]       -> e-mail do responsvelpelo envio da mensagem.
 //                                  Exemplo:
 //                                  oMessage:setProperty('From', "parcerias@sistemapointer.com, suporte@sistemapointer.com")
 //        [<cSenderReplyEmail>]  -> um nico endereo de e-mail para resposta ao e-mail enviado.
 //                                  Tem de ser uma conta de e-mail de <cSmtpServer> quando <cFrom> no foi
 //                                  informado ou se <cFrom> no for uma conta de e-mail vlida de
 //                                  <cSmtpServer>
 //                                  Obrigatrio quando <cFrom> no  uma conta de e-mail de <cSmtpServer>
 //                                  Assume <cSenderName>
 //        [<cSubject>]           -> Objeto da mensagem.
 //                                  Assume: ''
 //        [<cFrom>]              -> e_mail completo do(s) responsvel(is) pelo envio da mensagem.
 //                                  Em Xbase++ "From"  palavra reservada
 //                                  . Se o parmetro <cSendEmailAddress> for informado:
 //                                    .. <cFrom>  opcional e se assume o mesmo e-mail de <cSendEmailAddress>.
 //                                    .. se se precisar mais de um responsvel pelo envio da
 //                                       mensagem, o parmetro <cSendEmailAddress> tem de ser o
 //                                       primeiro e-mail de <cFrom>
 //                                  . Se o parmetro <cSendEmailAddress> no foi informado <cFrom>
 //                                     obrigatrio
 //                                  Pode-se especificar mais de um responsvel pelo envio, separados por
 //                                  vrgulas.
 //                                  Caso ocorra um nome no e-mail que contenha brancos, ele tem de estar
 //                                  entre aspas duplas.
 //
 //                                  Exemplos:
 //                                    '"Jane Doe" <example@example.com>, <example@example.com>, example2@example.com'
 //                                    '"John Jones, Jr." <example@example.com>, "Jane Doe" <example@example.com>'
 //        [<cTo>]                -> destinatrio(s) da mensagem.
//                                  Em Xbase++ "To"  palavra reservada
 //                                  A sintaxe  a mesma de <cFrom>.
 //                                  Tem-se de especificar pelo menos <cTo> ou <cCc> ou <cBcc> ou ambos
 //        [<cCc>]                -> destinatrio(s) de cpia da mensagem.
 //                                  A sintaxe  a mesma de <cFrom>.
 //                                  Tem-se de especificar pelo menos <cTo> ou <cCc> ou <cBcc> ou ambos
 //        [<cBcc>]               -> destinatrio(s) de cpia oculta da mensagem.
 //                                  A sintaxe  a mesma de <cFrom>.
 //                                  Tem-se de especificar pelo menos <cTo> ou <cCc> ou <cBcc> ou ambos
 //        [<ReplyTo>]            -> destinatrio da resposta do e-mail.
 //                                  Assume: <cFrom>
 //        [<cHTMLBody>]          -> corpo da mensagem em formato Html.
 //                                  Se <cHTMLBody> for informado <cTextBody> no pode ser informado.
 //                                  <cHTMLBody> tem precedncia sobre <cTextBody>
 //                                  Exemplo:
 //                                  "<h1>This is some sample message html.</h1>"
 //        [<cTextBody>]          -> corpo da mensagem em formato texto (com ou sem acentuao, de acordo com
 //                                  Set(_SET_CHARSET))
 //                                  Se <cTextBody> for informado, <cHTMLBody> no pode ser informado
 //                                  Assume: ''
 //        [<cKeyWords>]          -> palavra(s) chave da mensagem que possa ser utilizada para o(s) receptor(es)
 //                                  da mensagem determinar(em) ou selecionar a mensagem entre outras.
 //                                  Pode-se ter uma ou mais palavras, simples ou compostas, podendo ou no conter espaos.
 //                                  As palavras (ou cojunto de palavras) so separadas por vrgulas.
 //                                  Exemplos:
 //                                  "1997 payroll"
 //                                  "operating systems,Windows NT,functions"
 //        [<aAttachment>]        -> array contendo o encaminhamento completo dos arquivos a serem
 //                                  anexados
 //        [<nDSNOptions>]        -> como proceder em relao ao envio da mensagem:
 //                                  cdoDSNDefault             0  No delivery status notifications are issued.
 //                                  cdoDSNNever               1  No delivery status notifications are issued.
 //                                  cdoDSNFailure             2  Returns a delivery status notification if delivery fails.
 //                                  cdoDSNSuccess             4  Returns a delivery status notification if delivery succeeds.
 //                                  cdoDSNDelay               8  Returns a delivery status notification if delivery is delayed.
 //                                  cdoDSNSuccessFailOrDelay 14  Returns a delivery status notification if delivery succeeds,
 //                                                               fails, or is delayed.
 //                                  Default cdoDSNDefault
 //        [<@cError>]            -> varivel a ser utilizada com a mesagem de erro, se ocorrer.
 //                                  A mensagem pode conter vrias linhas separadas com CRLF
 //                                  Se no ocorrer erros conter ''.
 //
 //        RETORNA: .t. se a mensagem foi enviada corretamente. Neste caso o parmetro <cError> conter ''
 //                 .f. se ocorreu algum tipo de erro.          Neste caso o parmetro <cError> conter a mensagem de erro
 //
 //        Author:  Beling
 //        Date:    05.12.2012
 //        Revised:
 //
 /////
LOCAL   nInd,    oConfig, oFields,    oMessage, nLen, bError, e, aProcs,;
        cMethod, cUseSSl, cAuthentic, cDSNOPtions
                  //
                  //    Assume contedo
if nSendingMethod     == NIL
   nSendingMethod     := cdoSendUsingPort
endif
if nSmtpServerPort    == NIL
   nSmtpServerPort    := cdoServerPort
endif
if lSmtpUseSsl        == NIL
   lSmtpUseSsl        := .f.
endif
if nAuthenticate      == NIL
   nAuthenticate      :=cdoBasic
endif
if nConnectionTimeOut == NIL
   nConnectionTimeOut :=  60
endif

if cSenderPassWord   == NIL
   cSenderPassWord   := ''
endif
if cSenderEmail      == NIL
   cSenderEmail      := ''
endif
if cSenderReplyEmail == NIL
   cSenderReplyEmail := ''
endif

if cFrom             == NIL
   cFrom             := ''
endif
if cTo               == NIL
   cTo               := ''
endif
if cCc               == NIL
   cCc               := ''
endif
if cBCc               == NIL
   cBcc               := ''
endif
if cReplyTo           == NIL
   cReplyTo           := ''
endif
if cTextBody          == NIL
   cTextBody          := ''
endif
if cHTMLBody          == NIL
   cHTMLBody          := ''
endif

if (''       <> cHTMLBody)
   cTextBody := ''
endif

if cKeyWords   == NIL
   cKeyWords   := ''
endif

if nDSNOptions == NIL
   nDSNOptions := cdoDSNDefault
endif

if Empty(cFrom)             .and.;
   Empty(cSenderReplyEmail)
   cSenderReplyEmail := cSenderEmail
endif
                  //
                  //   The default ActiveX error handling raises runtime error when they occurs
cError := ''
bError := ErrorBlock({|e| Break(e)})
do while .t.
BEGIN SEQUENCE
                  //
                  //    Configuring the remote SMTP Server
   oConfig   := CreateObject("CDO.Configuration")
   if oConfig == NIL
      cError  := ComLastMessage()
      BREAK
   endif
   ApiSetLastError_()                     // "Cleaa" last error indication made by APIs
   oFields := oConfig:fields
   oFields:setProperty("Item", "urn:schemas:calendar:timezoneid",                                          cdoBrasilia)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/smtpserver",                cSmtpServer)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/sendusername",              cSenderName)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/sendpassword",              cSenderPassword)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/sendusing",                 cdoSendUsingPort)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/smtpserverport",            nSmtpServerPort)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/smtpusessl",                lSmtpUseSsl)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/smtpauthenticate",          nAuthenticate)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout",     nConnectionTimeOut)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/urlgetlatestversion",       .t.)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/senduserreplyemailaddress", cSenderReplyEmail)
   oFields:setProperty("Item", "http://schemas.microsoft.com/cdo/configuration/urlproxybypass",            '<local>')
   oFields:update()
                  //
                  //    Creates the message object
   oMessage := CreateObject("CDO.Message")
   cError   := ComLastMessage()
   if !Empty(cError)
      BREAK
   endif
                  //
                  //    Associates to the remote server
   oMessage:configuration := oConfig
   oMessage:DSNOptions    := nDSNOptions
   oMessage:Subject       :=    cSubject
   oMessage:setProperty('From', cFrom)  // "From" is reserved word in Xbase++
   oMessage:setProPerty('To',   cTo)    // "To"   is reserved word in Xbase++
   oMessage:cc          :=      cCc
   oMessage:bcc         :=      cBcc
   oMessage:replyTo     :=      cReplyTo
   if (''               <> cHTMLBody)
      oMessage:HTMLBody := cHTMLBody
   else
      oMessage:TextBody := cTextBody
   endif
   oMessage:KeyWords    := cKeyWords
                  //
                  //    Add attachments
   if !Empty(aAttachment)
      nLen := Len(aAttachment)
      for nInd := 1 to nLen
          oMessage:AddAttachment(aAttachment[nInd])
      next
   endif
                  //
                  //    Sending the message. In an error occurs porcesses the current error handling
   oMessage:Send()
   cError := ApiGetLastError_()
   ErrorBlock(bError)
RECOVER USING e
        ErrorBlock(bError)
        if Empty(cError)
           cError := ApiGetLastError_()
        endif
        if e <> NIL
           if !Empty(e:osCode)
              cError += (CR + 'OS Code: ' + LTrim(Str(e:osCode)))
           endif
           if !Empty(e:description)
              cError += (CR + 'Descrio: ' + e:description)
           endif
           if !Empty(e:operation)
              cError += (CR + 'Operao: '  + e:operation)
           endif
           aProcs := FazProc_(0, 3, .t., .f.)
           nLen   := Len(aProcs)
           for nInd := 1 to nLen
               cError += (CR + aProcs[nInd,01] + ', (' + LTrim(Str(aProcs[nInd, 02])) + ')')
           next
        endif
ENDSEQUENCE
   if oConfig  <> NIL
      oConfig:destroy()
      oConfig := NIL
   endif
   if oMessage <> NIL
      oMessage:destroy()
                  //
                  //    Tendo em vista que CDO.Message pode reter os anexos como reservados at
                  //          a finalizao do processo que enviou a mensagem, foraremos a
                  //    execuo do "Garbage Collector" do Xbase++ a fim de liberar todos os
                  //    recursos usados por CDO.Message
      oMessage := NIL
   endif
   exit
enddo
if !Empty(cError)
   if nSendingMethod == 1
      cMethod        := 'Using local SMTP service directory'
   else
      cMethod        := 'Using the network SMTP (over the network)'
   endif
   if lSmtpUseSsl
      cUseSSl        := 'Sim'
   else
      cUseSSl        := 'No'
   endif
   if     nAuthenticate == 1
          cAuthentic    := 'Usa autenticao bsica'
   elseif nAuthenticate == 2
          cAuthentic    := 'Usa segurana'
   else
          cAuthentic    := 'No autentica'
   endif
   if     nDSNOptions   == 1
          cDSNOptions   := 'No comunicar'
   elseif nDSNOptions   == 2
          cDSNOptions   := 'Comunicar erro ao enviar'
   elseif nDSNOptions   == 4
          cDSNOptions   := 'Comunicar a entrega ao prximo servidor'
   elseif nDSNOptions   == 8
          cDSNOptions   := 'Comunicar a solicitaao de confirmao da leitura'
   else
          cDSNOPtions   := 'Comunicar erro ao enviar, entrega e confirmao de leitura'
   endif

   cError := ('ApiSendMail_() erro no envio de mensagem:'                                    + CR +;
              'Server: '                                  + cSmtpServer                      + CR +;
              'Sending User: '                            + cSenderName                      + CR +;
              'Server port: '                             + LTrim(Str(nSmtpServerPort))      + CR +;
              'Usa SSL: '                                 + cUseSsl                          + CR +;
              'Autentificaco: '                          + cAuthentic                       + CR +;
              'Sending Method: '                          + cMethod                          + CR +;
              'Sucesso do Envio da mensagem: '            + cDSNOptions                 + CR + CR +;
              iif(!Empty(cSenderEmail), ('Sending Mail: ' + cSenderEmail + CR), '')               +;
              'From: '                                    + cFrom                            + CR +;
              iif(!Empty(cTo),            ('To: '         + cTo      + CR), '')              +;
              iif(!Empty(cCc),            ('Cc: '         + cCc      + CR), '')              +;
              iif(!Empty(cBcc),           ('Bcc: '        + cBcc     + CR), '')              +;
              iif(!Empty(cSubject),       ('Subject: '    + cSubject + CR), '')              + CR +;;
              'PROBLEMA: '                                                                   +;
              cError)
endif
RETURN Empty(cError)
